using System;   
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Collections;

namespace euler {
    class Problem27 {

        public static void Main(string[] args) {
            new Problem27().Smart();
        }

        int[] primes;

        public int[] ESieve(int upperLimit) {

            int sieveBound = (int)(upperLimit - 1) / 2;
            int upperSqrt = ((int)Math.Sqrt(upperLimit) - 1) / 2;

            BitArray PrimeBits = new BitArray(sieveBound + 1, true);

            for (int i = 1; i <= upperSqrt; i++) {
                if (PrimeBits.Get(i)) {
                    for (int j = i * 2 * (i + 1); j <= sieveBound; j += 2 * i + 1) {
                        PrimeBits.Set(j, false);
                    }
                }
            }

            List<int> numbers = new List<int>((int)(upperLimit / (Math.Log(upperLimit) - 1.08366)));
            numbers.Add(2);
            for (int i = 1; i <= sieveBound; i++) {
                if (PrimeBits.Get(i)) {
                    numbers.Add(2 * i + 1);
                }
            }

            return numbers.ToArray();
        }  

        public void Smart() {            
            Stopwatch clock = Stopwatch.StartNew();
            int aMax = 0, bMax = 0, nMax = 0;

            primes = ESieve(87400);
            int[] bPos = ESieve(1000);

                for (int a = -999; a < 1001; a +=2) {
                for (int i = 1; i < bPos.Length; i++) {                                        
                    for (int j = 0; j < 2; j++) {
                        int n = 0;
                        
                        int sign = (j == 0) ? 1 : -1;
                        int aodd = (i % 2 == 0) ? -1 : 0; // Making a even if b is even
                        while (isPrime(Math.Abs(n * n + (a + aodd) * n + sign*bPos[i]))) {
                            n++;
                        }

                        if (n > nMax) {
                            aMax = a;
                            bMax = bPos[i];
                            nMax = n;
                        }
                    }
                }
            }
            
            clock.Stop();     
            Console.WriteLine("A sequence of length {0}, is generated by a={1}, b={2}, the product is {3}", nMax, aMax, bMax, aMax*bMax);
            Console.WriteLine("Solution took {0} ms", clock.ElapsedMilliseconds);

        }

        private bool isPrime(int testNumber) {
            int i = 0;
            while (primes[i] <= testNumber) {
                if (primes[i] == testNumber) {
                    return true;
                }
                i++;
            }
            return false;            
        }              
    }

}
